/*
 * Hotcore Project Copyright (c) 2005
 */
package jp.hotcore.mayaa;

import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.seasar.mayaa.cycle.ServiceCycle;
import org.seasar.mayaa.engine.Page;
import org.seasar.mayaa.engine.processor.ProcessStatus;
import org.seasar.mayaa.engine.processor.ProcessorProperty;
import org.seasar.mayaa.impl.cycle.CycleUtil;
import org.seasar.mayaa.impl.engine.processor.TemplateProcessorSupport;
import org.seasar.mayaa.impl.util.StringUtil;

/**
 * ttH[}bgsvZbT[łB
 * 
 * @author shin@hotcore.jp
 *
 */
public class FormatDateProcessor extends TemplateProcessorSupport {

	private ProcessorProperty _value;
	private ProcessorProperty _pattern;
    private String _patternValue;

    public void setValue(ProcessorProperty value) {
    	// TODO ́Amayaa.midœt^ɌŒłƏyȂ̂łEEEB
    	_value = value;
    }

    public void setPattern(ProcessorProperty value) {
    	// TODO {́AIllegalArgumentExceptionLb`āA*.mayaãp[XɃG[񍐂B
    	_pattern = value;
    	_patternValue = (String)_pattern.getValue().execute(null);
    }

    private SimpleDateFormat getFormatter() {
        //TODO IuWFNgv[ɂ邩Acloneł̐̕ǂB
    	SimpleDateFormat theReturn = null;

    	if ( StringUtil.isEmpty(_patternValue )) {
    		theReturn = new SimpleDateFormat( _patternValue );
    	}    	
    	
    	return theReturn;
    }

    
    public ProcessStatus doStartProcess(Page topLevelPage) {
        if(_value != null) {
            String ret = (String)_value.getValue().execute(null);
            
            if(StringUtil.isEmpty(ret)) {
                //TODO {́AG[ɂׂȂ̂H
                ret = Utils.EMPTY;
            }

            SimpleDateFormat theFormatter = getFormatter();

            // L̏ƁADateɕϊłȂP[XL܂B
            Date theDate = theFormatter.parse( ret , new ParsePosition(0));
            if ( theDate != null ) {
            	ret = theFormatter.format( theDate );
            }

            ServiceCycle cycle = CycleUtil.getServiceCycle();
            cycle.getResponse().write(ret);
        }
        return ProcessStatus.SKIP_BODY;
    }

}
