/*
 * Hotcore Project Copyright (c) 2005
 */
package jp.hotcore.mayaa;

import java.text.DecimalFormat;

import org.seasar.mayaa.cycle.ServiceCycle;
import org.seasar.mayaa.engine.Page;
import org.seasar.mayaa.engine.processor.ProcessStatus;
import org.seasar.mayaa.engine.processor.ProcessorProperty;
import org.seasar.mayaa.impl.cycle.CycleUtil;
import org.seasar.mayaa.impl.engine.processor.TemplateProcessorSupport;
import org.seasar.mayaa.impl.util.StringUtil;

/**
 * l̃tH[}bgsvZbT[łB
 * 
 * @author shin@hotcore.jp
 *
 */
public class FormatNumberProcessor extends TemplateProcessorSupport {

	private ProcessorProperty _value;
	private ProcessorProperty _pattern;
    private String _patternValue;


    public void setValue(ProcessorProperty value) {
    	// TODO ́Amayaa.midjava.lang.Number^ɌŒłƏyȂ̂łEEEB
        _value = value;
    }

    public void setPattern(ProcessorProperty value) {
    	// TODO {́AIllegalArgumentExceptionLb`āA*.mayaãp[XɃG[񍐂B
    	_pattern = value;
    	_patternValue = (String)_pattern.getValue().execute(null);
    }

    private DecimalFormat getFormatter() {
        //TODO IuWFNgv[ɂ邩Acloneł̐̕ǂB
    	DecimalFormat theReturn = null;

    	if ( StringUtil.isEmpty( _patternValue )) {
    		theReturn = new DecimalFormat( _patternValue );
    	}    	
    	
    	return theReturn;
    }

    
    public ProcessStatus doStartProcess(Page topLevelPage) {
        if(_value != null) {
            String ret = (String)_value.getValue().execute(null);
            if(StringUtil.isEmpty(ret)) {
                //TODO {́AG[ɂׂȂ̂H
                ret = Utils.EMPTY;
            }

        	DecimalFormat theFormatter = getFormatter();

        	// ɏ_L΁ADoubleŕϊ`łB
        	// Valuě^킩΁AƏ̂łEEEB
        	if ( ret.indexOf( Utils.DOT ) >= 0 ) {
        		try {
        			double theDouble = Double.parseDouble( ret );
        			
        			ret = theFormatter.format( theDouble );
        		} catch ( NumberFormatException theErr ) {
        			
        		}
        	} else {
        		try {
        			long theLong = Long.parseLong( ret );
        			
        			ret = theFormatter.format( theLong );
        		} catch ( NumberFormatException theErr ) {
        			
        		}
        	}

            ServiceCycle cycle = CycleUtil.getServiceCycle();
            cycle.getResponse().write(ret);
        }
        return ProcessStatus.SKIP_BODY;
    }

}
